;; Problem 43
;; 09 May 2003

;; The number, 1406357289, is a 0 to 9 pandigital number because it is made up of each of the digits 0 to 9 in some order, but it also has a rather interesting sub-string divisibility property.

;; Let d1 be the 1st digit, d2 be the 2nd digit, and so on. In this way, we note the following:

;;     * d2d3d4=406 is divisible by 2
;;     * d3d4d5=063 is divisible by 3
;;     * d4d5d6=635 is divisible by 5
;;     * d5d6d7=357 is divisible by 7
;;     * d6d7d8=572 is divisible by 11
;;     * d7d8d9=728 is divisible by 13
;;     * d8d9d10=289 is divisible by 17

;; Find the sum of all 0 to 9 pandigital numbers with this property.

;; fourth char has to be even
;; fifth has to be odd
;; sixth has to be zero or five
;; 

;; d1 can not be zero
;; d4 has to be 2,4,6,8,0
;; d6 has to be 5,0

(defvar *digits* '(0 1 2 3 4 5 6 7 8 9))

(defun trip->num (d1 d2 d3)
  (+
   (* 100 d1)
   (*  10 d2)
   (*   1 d3)))

;; (trip->num 1 2 3)

(defun find-pandigital (&optional max)
  (let ((res (list)))
    (loop 
     with num-tested = 0
     for d1 in '(1 2 3 4 5 6 7 8 9)
     do
     (loop 
      for d2 in (remove d1 *digits*)
      for rem2 = (remove d1 (remove d2 *digits*)) then (remove d1 (remove d2 *digits*))
      do
      (loop 
       for d3 in (remove d2 rem2)
       for rem3 = (remove d3 rem2) then (remove d3 rem2)
       do
       (loop ;; d4 has to be even...
	for d4 in (remove-if #'oddp (remove d3 rem3))
	for rem4 = (remove d4 rem3) then (remove d4 rem3)
	do
	(loop 
	 for d5 in (remove d4 rem4)
	 for rem5 = (remove d5 rem4) then (remove d5 rem4)
	 do
	 (loop ;; d6 has to be divisble by 5
	  for d6 in (remove-if #'(lambda (num)
				   (not (= 0 (mod num 5))))
			       (remove d5 rem5))
	  for rem6 = (remove d6 rem5) then (remove d6 rem5)
	  do
	  (loop 
	   for d7 in (remove d6 rem6)
	   for rem7 = (remove d7 rem6) then (remove d7 rem6)
	   do
	   (loop 
	    for d8 in (remove d7 rem6)
	    for rem8 = (remove d8 rem7) then (remove d8 rem7)
	    do
	    (loop 
	     for d9 in (remove d8 rem7)
	     for rem9 = (remove d9 rem8) then (remove d7 rem8)
	     do
	     (loop 
	      for d10 in (remove d9 rem8)
	      for rem10 = (remove d10 rem9) then (remove d8 rem9)
	      do
	      (let ((str (format nil "~a~a~a~a~a~a~a~a~a~a" d1 d2 d3 d4 d5 d6 d7 d8 d9 d10)))
		;;(format t "max:~a num: ~a~&" max str)
		(incf num-tested)
		(when (and (= 0 (mod (trip->num d2 d3 d4)   2))
			   (= 0 (mod (trip->num d3 d4 d5)   3))
			   (= 0 (mod (trip->num d4 d5 d6)   5))
			   (= 0 (mod (trip->num d5 d6 d7)   7))
			   (= 0 (mod (trip->num d6 d7 d8)  11))
			   (= 0 (mod (trip->num d7 d8 d9)  13))
			   (= 0 (mod (trip->num d8 d9 d10) 17)))
		  (format t "found w/property: ~a~&" str)
		  (push str res))
		(if (and max (< max num-tested))
		    (return-from find-pandigital res)))))))))))))
    (format t "res:~a~&" res)
    res))

(declaim (inline fact))

(defun fact (n)
  (declare (optimize speed)
	   (type number n))
  (when (= 0 n)
    (return-from fact 1))
   (loop
    for ii from 1 to n
    for ff = ii then (* ff ii)
    finally (return ff)))

(fact 9)

;;(find-pandigital 400000)
;; (time (find-pandigital 100000)) ~9seconds

(time (find-pandigital))

(+ 4160357289 4130952867 4106357289 1460357289 1430952867 1406357289)

;; 16695334890